SystemOrganization addCategory: #Proxies!

Object subclass: #ClassProxyFileOut
	instanceVariableNames: 'superclass methodDict format className'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies'!

!ClassProxyFileOut methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 10/17/2010 17:02'!
become: aClass
	| classNameBkp |
	className := aClass name.
	"FileDirectory default  deleteFileNamed: aClass name, '.st'  ifAbsent: [].
	"aClass fileOut.
	"Smalltalk removeClassNamed: className.
	"
	super become: aClass
! !

!ClassProxyFileOut methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 10/15/2010 19:49'!
doesNotUnderstand: aMessage
	self restore. 
	^ self perform: aMessage selector withArguments: aMessage arguments! !

!ClassProxyFileOut methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 10/15/2010 19:52'!
fileInClass.
	(FileStream fileNamed: className, '.st') fileIn.
	^ Smalltalk at: className. 
	! !

!ClassProxyFileOut methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 10/15/2010 19:50'!
initialize
	super initialize.
	superclass := ProxySuperclass.
	methodDict := nil.
! !

!ClassProxyFileOut methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 10/15/2010 20:08'!
restore
	Transcript show: 'Will restore class'; cr.
	super become: self fileInClass.
	Transcript show: 'Class restored'; cr.
! !

Object subclass: #ClassProxyInstVar
	instanceVariableNames: 'superclass methodDict format actualClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies'!

!ClassProxyInstVar methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 10/15/2010 19:04'!
doesNotUnderstand: aMessage
	self restore. 
	^ self perform: aMessage selector withArguments: aMessage arguments! !

!ClassProxyInstVar methodsFor: 'initialize-release' stamp: 'NouryBouraqadi 10/1/2010 14:57'!
initialize
	super initialize.
	superclass := ProxySuperclass.
	methodDict := nil.
	actualClass := self! !

!ClassProxyInstVar methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 10/2/2010 19:28'!
restore
	Transcript show: 'Will restore class'; cr.
	self become: actualClass.
	Transcript show: 'Class restored'; cr.
! !

Object variableSubclass: #MessageCatchingProxy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies'!

MessageCatchingProxy class
	instanceVariableNames: 'unwrapSelector object'!

MessageCatchingProxy class
	instanceVariableNames: 'unwrapSelector object'!

!MessageCatchingProxy class methodsFor: 'as yet unclassified' stamp: 'sig 11/24/2008 23:56'!
handleMessage: aMessage forProxy: proxy

	self shouldBeImplemented ! !

!MessageCatchingProxy class methodsFor: 'as yet unclassified' stamp: 'sig 11/24/2008 23:55'!
setObject: anObject

	object := anObject! !

!MessageCatchingProxy class methodsFor: 'as yet unclassified' stamp: 'sig 11/24/2008 23:56'!
wrap: anObject

	| anonClass |
	
	anonClass := self clone.
	anonClass setObject: anObject; methodDict: nil ; superclass: self.
	
	^ anonClass basicNew! !

!MessageCatchingProxy methodsFor: 'as yet unclassified' stamp: 'sig 11/25/2008 00:03'!
cannotInterpret: aMessage
	^ aMessage lookupClass handleMessage: aMessage forProxy: self
! !

Object subclass: #ObjectProxy
	instanceVariableNames: 'fileName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies'!

!ObjectProxy classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/29/2010 15:39'!
aTest

| o p |
o := MyClass new.
o foo: 123.
p := ClassProxy3 new.
p become: MyClass.
MyClass flushCache.
ClassProxy3 flushCache.
o == nil.
Transcript show: o class name; cr.
o foo.
! !

!ObjectProxy classSide methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/29/2010 16:51'!
forFileName: aFileName
	^ self new fileName: aFileName ! !

!ObjectProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/17/2010 17:09'!
become: anObject
	fileName := self serializeAndWriteToDisk: anObject.
	anObject becomeForward: self. ! !

!ObjectProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/29/2010 16:35'!
doesNotUnderstand: aMessage
	self becomeForward: self loadBackSerializedObjectsFromFile.
	^ self perform: aMessage selector withArguments: aMessage arguments! !

!ObjectProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 9/29/2010 16:19'!
fileName
	^ fileName! !

!ObjectProxy methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 9/29/2010 16:19'!
fileName: anObject
	fileName := anObject! !

!ObjectProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/17/2010 19:13'!
fooSomething
	^ 'fooSomethingProxy'! !

!ObjectProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/29/2010 16:49'!
loadBackSerializedObjectsFromFile

	| file result |
	file := FileStream fileNamed: self fileName.
	file binary.
	result := (ReferenceStream on: file) next.
	file close.
	^ result! !

!ObjectProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/17/2010 17:09'!
serializeAndWriteToDisk: anObject	
	| file result |

	file := FileStream fileNamed: (self name, ' test').
	file binary.
	(ReferenceStream on: file) nextPut: anObject.
	file close.
	^ self name, ' test'.! !

Object subclass: #ObjectSwapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies'!

!ObjectSwapper methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/30/2010 10:03'!
serializeAndWriteToDisk: anObject	
	| file result |

	file := FileStream fileNamed: (self name, ' test').
	file binary.
	(ReferenceStream on: file) nextPut: anObject.
	file close.
	^ self name, ' test'.! !

!ObjectSwapper methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 9/30/2010 16:43'!
swap: anObject
	| fileName proxy |
	fileName := self serializeAndWriteToDisk: anObject. 
	
	"make this nicer"
	anObject isBehavior 
		ifTrue: [proxy := AClassProxy forFileName: fileName.]
		ifFalse: [proxy := ObjectProxy forFileName: fileName.].
	
	anObject becomeForward: proxy. ! !

Object subclass: #ProxySuperclass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Proxies'!

!ProxySuperclass methodsFor: 'swapping' stamp: 'NouryBouraqadi 10/1/2010 15:08'!
cannotInterpret: aMessage
	Transcript cr; 
		show: 'cannotInterpret:';
		space;
		show: aMessage selector..
	self class restore.
	^aMessage sendTo: self! !
